/*
	Progress bars for actions, where we have to wait for Tomcat to do something
*/
function set_prog_cts_new(seconds){
	// set all necessary values. this includes text, intern % value and prog bar width
	$('#prog_cts_new').text(seconds + "s");
	$('#prog_cts_new').css('width', seconds*3.3334 + "%");
	$('#prog_cts_new').attr('aria-valuenow', "" + seconds);
};
function get_prog_cts_new(){
	// do not use the width value, since this is in px and not in %
	return parseInt($('#prog_cts_new').attr("aria-valuenow"));
};
function auto_progress_bar_cts_new(){
	// avoid going further than 100%
	var v = get_prog_cts_new() + 1;
	if(v > 30){ v = 30; }
	set_prog_cts_new( v );
};





function set_prog_rename(seconds){
	// set all necessary values. this includes text, intern % value and prog bar width
	$('#prog_cts_rename').text(seconds + "s");
	$('#prog_cts_rename').css('width', seconds*3.3334 + "%");
	$('#prog_cts_rename').attr('aria-valuenow', "" + seconds);
};
function get_prog_rename(){
	// do not use the width value, since this is in px and not in %
	return parseInt($('#prog_cts_rename').attr("aria-valuenow"));
};
function auto_progress_bar_rename(){
	// avoid going further than 100%
	var v = get_prog_rename() + 1;
	if(v > 30){ v = 30; }
	set_prog_rename( v );
};



// 60 seconds
function set_prog_update(seconds){
	// set all necessary values. this includes text, intern % value and prog bar width
	$('#prog_cts_update').text(seconds + "s");
	$('#prog_cts_update').css('width', seconds*3.3334/2 + "%");
	$('#prog_cts_update').attr('aria-valuenow', "" + seconds);
};
function get_prog_update(){
	// do not use the width value, since this is in px and not in %
	return parseInt($('#prog_cts_update').attr("aria-valuenow"));
};
function auto_progress_bar_update(){
	// avoid going further than 100%
	var v = get_prog_update() + 1;
	if(v > 60){ v = 60; }
	set_prog_update( v );
};




function set_prog_delete(seconds){
	// set all necessary values. this includes text, intern % value and prog bar width
	$('#prog_cts_delete').text(seconds + "s");
	$('#prog_cts_delete').css('width', seconds*3.3334 + "%");
	$('#prog_cts_delete').attr('aria-valuenow', "" + seconds);
};
function get_prog_delete(){
	// do not use the width value, since this is in px and not in %
	return parseInt($('#prog_cts_delete').attr("aria-valuenow"));
};
function auto_progress_bar_delete(){
	// avoid going further than 100%
	var v = get_prog_delete() + 1;
	if(v > 30){ v = 30; }
	set_prog_delete( v );
};


function set_prog_browser(seconds){
	// set all necessary values. this includes text, intern % value and prog bar width
	$('#prog_browser').text(seconds + "s");
	$('#prog_browser').css('width', seconds*10 + "%");
	$('#prog_browser').attr('aria-valuenow', "" + seconds);
};
function get_prog_browser(){
	// do not use the width value, since this is in px and not in %
	return parseInt($('#prog_browser').attr("aria-valuenow"));
};
function auto_progress_bar_browser(){
	// avoid going further than 100%
	var v = get_prog_browser() + 1;
	if(v > 10){ v = 10; }
	set_prog_browser( v );
};

function set_prog_alignbrowser(seconds){
	// set all necessary values. this includes text, intern % value and prog bar width
	$('#prog_alignbrowser').text(seconds + "s");
	$('#prog_alignbrowser').css('width', seconds*5 + "%");
	$('#prog_alignbrowser').attr('aria-valuenow', "" + seconds);
};
function get_prog_alignbrowser(){
	// do not use the width value, since this is in px and not in %
	return parseInt($('#prog_alignbrowser').attr("aria-valuenow"));
};
function auto_progress_bar_alignbrowser(){
	// avoid going further than 100%
	var v = get_prog_alignbrowser() + 1;
	if(v > 20){ v = 20; }
	set_prog_alignbrowser( v );
};

function set_prog_parallelbrowser(seconds){
	// set all necessary values. this includes text, intern % value and prog bar width
	$('#prog_parallelbrowser').text(seconds + "s");
	$('#prog_parallelbrowser').css('width', seconds*5 + "%");
	$('#prog_parallelbrowser').attr('aria-valuenow', "" + seconds);
};
function get_prog_parallelbrowser(){
	// do not use the width value, since this is in px and not in %
	return parseInt($('#prog_parallelbrowser').attr("aria-valuenow"));
};
function auto_progress_bar_parallelbrowser(){
	// avoid going further than 100%
	var v = get_prog_parallelbrowser() + 1;
	if(v > 20){ v = 20; }
	set_prog_parallelbrowser( v );
};




function tc_url(){
	return $('#base_url').text().trim() ;
};



function usermanagement_ruby_feedback(res){
	// parse the feedback
	var obj = JSON.parse(res);
	// clear fadeouts anyway
	if(typeof usermanagement_fade1 !== 'undefined' &&  typeof usermanagement_fade2 !== 'undefined'){
		clearTimeout(usermanagement_fade1);
		clearTimeout(usermanagement_fade2);
	}
	$('#div_feedback_usermanagement').removeClass('myout');
	
	// show messages
	if(obj.succ === true){
		// give some feedback
		$('#div_feedback_usermanagement').text( obj.msg );
		$("#div_feedback_usermanagement").addClass("alert-success");
		$("#div_feedback_usermanagement").removeClass("alert-danger");
		$('#div_feedback_usermanagement').css("display", "block");
		usermanagement_fade1 = window.setTimeout(function() {  
			$('#div_feedback_usermanagement').addClass('myout');
			usermanagement_fade2 = window.setTimeout(function() {
				$('#div_feedback_usermanagement').removeClass('myout');
				$('#div_feedback_usermanagement').css("display", "none");
			}, 2000);
		}, 5000);
	} else {
		// show message
		$("#div_feedback_usermanagement").text(obj.msg);
		// indicate as error
		$("#div_feedback_usermanagement").removeClass("alert-success");
		$("#div_feedback_usermanagement").addClass("alert-danger");
		$('#div_feedback_usermanagement').css("display", "block");
	}
}










/*
	JS actions for different actions. Mainly for click-events
*/

function func_ready() {
	
	// save the specified parameters to file
	$('#btn_save_parameters').click( function(){
		var ret = [];
		// iterate over all table rows (1 row = 1 parameter)
		$("tr.parameter_row").each(function() {
			var pname 		= $(this).find("td.parameter_name").html();
			var pvalue 		= $(this).find("input.parameter_value").val();
			var poldvalue 	= $(this).find("input.parameter_value").attr("old-value");
			
			// get the value of the parameter. if it is a checkbox (= boolean parameter), get the "checked" status
			if( $(this).find("input.parameter_value").prop("type") === "checkbox" ){
				pvalue 	= $(this).find("input.parameter_value").prop("checked");
			}
			// also get, if any, the comment. Save all stuff to an array
			var pcomment = $(this).find("td.parameter_comment").html();
			ret.push( {name: pname, value: pvalue, oldvalue: poldvalue, comment: pcomment  } );
		});
		
		// send all parameternames, values and comments to ruby
		$.post(tc_url() + "/ajax_save_parameters", { 	name: $("#span_ctsname").text() , 
														values: ret } , 
			function(res){
				// get the results, parse as object and give some feedback
				var obj = JSON.parse(res);
				// update feed-back area: make area visible and add text and change colour according to success or error
				$('#div_feedback_save_db_params').css("display", "block");
				$('#div_feedback_save_db_params_text').text( obj.msg );
				
				if(obj.success === true){
					$('#div_feedback_save_db_params').removeClass('alert-danger');
					$('#div_feedback_save_db_params').addClass('alert-success');
				}else{
					$('#div_feedback_save_db_params').removeClass('alert-success');
					$('#div_feedback_save_db_params').addClass('alert-danger');
				}
				window.setTimeout(function() {  
					$('#div_feedback_save_db_params').delay(1000).addClass('myout');
					window.setTimeout(function() {
						$('#div_feedback_save_db_params').delay(1000).removeClass('myout');
						$('#div_feedback_save_db_params').css("display", "none");
					}, 1000);
				}, 4000);
			});
	});
	
	
	
	
	// drop the MySQL-Table
	$("#btn_table_drop").click(function() {
		// get confirmation string
		var str = $('#txt_table_drop').val();
		str = str.toUpperCase();
		// confirm the deletion with OK in a textfield
		if( str === "OK" || str === "'OK'"){
			// the ruby process will wait no longer than 30s for Tomcat to remove the folder
			$.post( tc_url() + "/ajax_drop_table", { name: $('#span_ctsname_drop').text() }, function(res){
				// get the results, parse as object and give some feedback
				var obj = JSON.parse(res);
				// update feed-back area: make area visible and add text and change colour according to success or error
				$('#div_feedback_table_drop').css("display", "block");
				$('#div_feedback_table_drop_text').text( obj.msg );
				
				if(obj.succ === true){
					$('#div_feedback_table_drop').removeClass('alert-danger');
					$('#div_feedback_table_drop').addClass('alert-success');
				}else{
					$('#div_feedback_table_drop').removeClass('alert-success');
					$('#div_feedback_table_drop').addClass('alert-danger');
				}
			});
				
		} else {
			$('#div_feedback_table_drop').css("display", "block");
			$('#div_feedback_table_drop_text').text( "Please confirm with an OK in the textfield above" );
			$('#div_feedback_table_drop').removeClass('alert-success');
			$('#div_feedback_table_drop').addClass('alert-danger');
		}
	});
	
	
	
	
	
	// create a new CTS instance
	$('#btn_cts_create_new').click( function(){
		// get the name of the new cts instance
		var new_name = $('#txt_cts_new_name').val();
		
		// progress-bar stuff
		set_prog_cts_new(1);
		var prog_id = window.setInterval(auto_progress_bar_cts_new, 1000);
		$('#div_prog_new').css("display", "block");
		$('#prog_cts_new').addClass("active");
		$('#div_feedback_create_cts').css("display", "none");
		
		// the ruby process will wait no longer than 30s for Tomcat to add the folder
		$.post( tc_url() + "/ajax_create_new_cts", { new_name: new_name } , 
			function(res){
				// once we reached this part, the folder has been removed and added again. stop the progressbar and give feedback
				clearInterval(prog_id);
				$('#prog_cts_new').removeClass("active");
				
				// get the results, parse as object and give some feedback
				var obj = JSON.parse(res);
				// update feed-back area: make area visible and add text and change colour according to success or error
				$('#div_feedback_create_cts').css("display", "block");
				$('#div_feedback_create_cts_text').html( obj.msg );
				
				if(obj.success === true){
					$('#div_feedback_create_cts').removeClass('alert-danger');
					$('#div_feedback_create_cts').addClass('alert-success');
				}else{
					$('#div_feedback_create_cts').removeClass('alert-success');
					$('#div_feedback_create_cts').addClass('alert-danger');
				}
				
			});
	});
	
	
	
	
	// rename the current CTS
	$('#btn_cts_rename').click( function(){
		// get the old and the new name
		var old_name = $('#ctsname_rename').text();
		var new_name = $('#txt_cts_rename').val();
		
		// progress-bar stuff
		set_prog_rename(1);
		var prog_id = window.setInterval(auto_progress_bar_rename, 1000);
		$('#div_prog_rename').css("display", "block");
		$('#prog_cts_rename').addClass("active");
		$('#div_feedback_rename_cts').css("display", "none");
		
		// the ruby process will wait no longer than 30s for Tomcat to remove and add the folder
		$.post( tc_url() + "/ajax_rename_cts", { old_name: old_name, new_name: new_name } , 
			function(res){
				// once we reached this part, the folder has been removed and added again. stop the progressbar and give feedback
				clearInterval(prog_id);
				$('#prog_cts_rename').removeClass("active");
				
				// get the results, parse as object and give some feedback
				var obj = JSON.parse(res);
				
				$('#div_feedback_rename_cts').css("display", "block");
				$('#div_feedback_rename_cts_text').html( obj.msg );
				
				if(obj.success === true){
					$('#div_feedback_rename_cts').removeClass('alert-danger');
					$('#div_feedback_rename_cts').addClass('alert-success');
					window.setTimeout(function() { window.location = obj.to; }, 5000);
				} else{
					$('#div_feedback_rename_cts').removeClass('alert-success');
					$('#div_feedback_rename_cts').addClass('alert-danger');
				}
				
			} );
	});
	
	
	// update the current CTS
	$('#btn_cts_update').click( function(){
		// get the old and the new name
		var cts_name = $("#ctsname_update").text();
		
		// progress-bar stuff
		set_prog_update(1);
		var prog_id = window.setInterval(auto_progress_bar_update, 1000);
		$('#prog_cts_update').addClass("active");
		$('#div_prog_update').css("display", "block");
		$('#div_feedback_update_cts').css("display", "none");
		
		// the ruby process will wait no longer than 30s for Tomcat to remove and add the folder
		$.post( tc_url() + "/ajax_update_cts", { cts_name: cts_name } , 
			function(res){
				// once we reached this part, the folder has been removed and added again. stop the progressbar and give feedback
				clearInterval(prog_id);
				$('#prog_cts_update').removeClass("active");
				
				// get the results, parse as object and give some feedback
				var obj = JSON.parse(res);
				
				$('#div_feedback_update_cts').css("display", "block");
				$('#div_feedback_update_cts_text').html( obj.msg );
				
				if(obj.success === true){
					$('#div_feedback_update_cts').removeClass('alert-danger');
					$('#div_feedback_update_cts').addClass('alert-success');
				} else{
					$('#div_feedback_update_cts').removeClass('alert-success');
					$('#div_feedback_update_cts').addClass('alert-danger');
				}
				
			} );
	});
	
	
	
	// delete the current cts
	$('#btn_cts_delete').click( function(){
		// get confirmation string
		var str = $('#txt_cts_delete').val();
		str = str.toUpperCase();
		// confirm the deletion with OK in a textfield
		if( str === "OK" || str === "'OK'"){
			// progress-bar stuff
			set_prog_delete(1);
			var prog_id = window.setInterval(auto_progress_bar_delete, 1000);
			$('#div_prog_delete').css("display", "block");
			$('#prog_cts_delete').addClass("active");
			$('#div_feedback_delete_cts').css("display", "none");
			
			// the ruby process will wait no longer than 30s for Tomcat to remove the folder
			$.post( tc_url() + "/ajax_delete_cts", { name: $('#ctsname_delete').text() } , 
				function(res){
					// once we reached this part, the folder has been removed and added again. stop the progressbar and give feedback
					clearInterval(prog_id);
					$('#prog_cts_delete').removeClass("active");
				
					// get the results, parse as object and give some feedback
					var obj = JSON.parse(res);
					
					$('#div_feedback_delete_cts').css("display", "block");
					$('#div_feedback_delete_cts_text').html( obj.msg );
					
					if(obj.success === true){
						$('#div_feedback_delete_cts').removeClass('alert-danger');
						$('#div_feedback_delete_cts').addClass('alert-success');
						window.setTimeout(function() { window.location = obj.to; }, 5000);
					} else{
						$('#div_feedback_delete_cts').removeClass('alert-success');
						$('#div_feedback_delete_cts').addClass('alert-danger');
					}
					
				});
		} else {
			$('#div_feedback_delete_cts').css("display", "block");
			$('#div_feedback_delete_cts_text').html( "Please confirm the deletion with 'OK' in the textfield above!" );
			$('#div_feedback_delete_cts').removeClass('alert-success');
			$('#div_feedback_delete_cts').addClass('alert-danger');
		}
	});
	
	
	
	// import data
	$('#btn_import_data').click( function(){
		$.post( tc_url() + "/ajax_get_para_resetdb", { name: $('#span_ctsname').text() }, 
			function(res){
				var ret = JSON.parse(res);
				if (ret.reset === "true" && $('#btn_import_data').hasClass("btn-primary") ) {
					$('#btn_import_data').removeClass("btn-primary");
					$('#btn_import_data').addClass("btn-warning");
					$('#btn_import_data').text("resetDB = true. This will reset the database '" + ret.dbname + "'. Click again to continue.");
					
				} else{
					$('#btn_import_data').addClass("btn-primary");
					$('#btn_import_data').addClass("disabled");
					$('#btn_import_data').removeClass("btn-warning");
					$('#btn_import_data').text("import running for '" + $('#span_ctsname').text() + "'");
					// trigger importing in ruby
					$.post( tc_url() + "/ajax_import_data", { name: $('#span_ctsname').text() }, 
						function(res){
							// get the results, parse as object and give some feedback
							var obj = JSON.parse(res);
							// alert if there were any errors
							if (obj.success === false){
								alert(obj.message);
							}
						});
				};
			});
	});
	
	// cancel the import
	$("#btn_cancel_import").click( function(){
		if( ! $("#btn_cancel_import").hasClass("cancel_confirm") ){
			$("#btn_cancel_import").text("This will cancel the import. Please press again to continue.");
			$("#btn_cancel_import").addClass("cancel_confirm");
		} else {
			$("#btn_cancel_import").removeClass("cancel_confirm")
			$.post( tc_url() + "/ajax_cancel_import", {name: $('#span_ctsname').text()}, 
				function(res){
					var ret = JSON.parse(res);
					console.dir(ret);
					if(ret.succ === true){
						$("#div_feedback_import").addClass('alert-success');
						$("#div_feedback_import").removeClass('alert-danger');
					} else {
						$("#div_feedback_import").removeClass('alert-success');
						$("#div_feedback_import").addClass('alert-danger');
					}
					$("#div_feedback_import").css("display", "block");
					$("#div_feedback_import").html(ret.msg);
				});
		}
		
	});
	
	
	// delete recent activities history
	$("#btn_reset_activities").click( function(){
		$.post( tc_url() + "/ajax_reset_activities", {}, 
			function(res){
				$("#recent_activities_container").html("");
			});
	});
	
	
	// create new Browser if not present
	$("#btn_create_browser").click( function(){
		// progress-bar stuff
		set_prog_browser(1);
		var prog_id = window.setInterval(auto_progress_bar_browser, 1000);
		$('#div_prog_browser').css("display", "block");
		$('#prog_browser').addClass("active");
		$("#btn_create_browser").addClass("disabled");
		
		$.post( tc_url() + "/ajax_create_browser", {name: $("#span_browser_ctsname").attr("data-ctsname")}, 
			function(res){
				// once we reached this part, the folder has added. stop the progressbar and give feedback
				clearInterval(prog_id);
				$('#prog_cts_browser').removeClass("active");
					
				var ret = JSON.parse(res);
				console.dir(ret);
				if(ret.succ === true){
						$("#div_feedback_create_browser").addClass('alert-success');
						$("#div_feedback_create_browser").removeClass('alert-danger');
					} else {
						$("#div_feedback_create_browser").removeClass('alert-success');
						$("#div_feedback_create_browser").addClass('alert-danger');
					}
					$("#div_feedback_create_browser").css("display", "block");
					$("#div_feedback_create_browser_text").html(ret.msg);
			});
	});

	// create new Alignment-Browser if not present
	$("#btn_create_alignbrowser").click( function(){
		// progress-bar stuff
		set_prog_alignbrowser(1);
		var prog_id = window.setInterval(auto_progress_bar_alignbrowser, 1000);
		$('#div_prog_alignbrowser').css("display", "block");
		$('#prog_alignbrowser').addClass("active");
		$("#btn_create_alignbrowser").addClass("disabled");
		
		$.post( tc_url() + "/ajax_create_alignbrowser", {name: $("#span_align_ctsname").attr("data-ctsname")}, 
			function(res){
				// once we reached this part, the folder has added. stop the progressbar and give feedback
				clearInterval(prog_id);
				$('#prog_cts_alignbrowser').removeClass("active");
					
				var ret = JSON.parse(res);
				console.dir(ret);
				if(ret.succ === true){
						$("#div_feedback_create_alignbrowser").addClass('alert-success');
						$("#div_feedback_create_alignbrowser").removeClass('alert-danger');
					} else {
						$("#div_feedback_create_alignbrowser").removeClass('alert-success');
						$("#div_feedback_create_alignbrowser").addClass('alert-danger');
					}
					$("#div_feedback_create_alignbrowser").css("display", "block");
					$("#div_feedback_create_alignbrowser_text").html(ret.msg);
			});
	});

	// create new Alignment-Browser if not present
	$("#btn_create_parallelbrowser").click( function(){
		// progress-bar stuff
		set_prog_parallelbrowser(1);
		var prog_id = window.setInterval(auto_progress_bar_parallelbrowser, 1000);
		$('#div_prog_parallelbrowser').css("display", "block");
		$('#prog_parallelbrowser').addClass("active");
		$("#btn_create_parallelbrowser").addClass("disabled");
		
		$.post( tc_url() + "/ajax_create_parallelbrowser", {name: $("#span_parallel_ctsname").attr("data-ctsname")}, 
			function(res){
				// once we reached this part, the folder has added. stop the progressbar and give feedback
				clearInterval(prog_id);
				$('#prog_cts_parallelbrowser').removeClass("active");
					
				var ret = JSON.parse(res);
				console.dir(ret);
				if(ret.succ === true){
						$("#div_feedback_create_parallelbrowser").addClass('alert-success');
						$("#div_feedback_create_parallelbrowser").removeClass('alert-danger');
					} else {
						$("#div_feedback_create_parallelbrowser").removeClass('alert-success');
						$("#div_feedback_create_parallelbrowser").addClass('alert-danger');
					}
					$("#div_feedback_create_parallelbrowser").css("display", "block");
					$("#div_feedback_create_parallelbrowser_text").html(ret.msg);
			});
	});
	

	// ################################################################################
	// #####  Help Menu entries  ######################################################
	// ################################################################################
	
	$("#btn_helpmenu_defaults").click(function() {
		// create a valid object. here, an array of link objects for the help menu
		var obj = [	{text: "contact", 		href: "mailto:jtiepmar@informatik.uni-leipzig.de"}, 
					{text: "CTS iterator", 	href: "http://ctstest.informatik.uni-leipzig.de/"}];
		// fill the textarea with a pretty printed json (native function, indent.-width as third argument)
		$("#txt_helpmenu_json").prop("value", JSON.stringify(obj, null, 4) );
	});
	
	$("#btn_helpmenu_save").click(function() {
		// parse the JSON and give an error, if something went wrong
		try {
			var txt = $("#txt_helpmenu_json").prop("value");
			var obj = JSON.parse( txt );
			
			$.post( tc_url() + "/ajax_helpmenu_save", {text: txt}, function(res){
				if(res === "OK"){
					$("#div_feedback_helpmenu_text").text("Help menu entries have been saved successfully!");
					$("#div_feedback_helpmenu").addClass("alert-success");
					$("#div_feedback_helpmenu").removeClass("alert-danger");
					$("#div_feedback_helpmenu").css("display", "block");
				} else {
					$("#div_feedback_helpmenu_text").text(res);
					$("#div_feedback_helpmenu").removeClass("alert-success");
					$("#div_feedback_helpmenu").addClass("alert-danger");
					$("#div_feedback_helpmenu").css("display", "block");
				}
			});
		} catch(err) {
			$("#div_feedback_helpmenu_text").text(err.message);
			$("#div_feedback_helpmenu").removeClass("alert-success");
			$("#div_feedback_helpmenu").addClass("alert-danger");
			$("#div_feedback_helpmenu").css("display", "block");
		}
	});
	
	// ################################################################################
	// #####  general settings   ######################################################
	// ################################################################################
	
	// restore default values
	$("#btn_settings_defaults").click(function() {
		// fill the textarea with a pretty printed json (native function, indent.-width as third argument)
		$("#txt_urn_separator").prop("value", "_" );
	});
	
	
	$("#btn_settings_save").click(function() {
		// parse the JSON and give an error, if something went wrong
		try {
			var txt_urn_separator = $("#txt_urn_separator").prop("value");
						
			$.post( tc_url() + "/ajax_settings_save", {urn_separator: txt_urn_separator}, function(res){
				if(res === "OK"){
					$("#div_feedback_settings_text").text("Settings have been saved successfully!");
					$("#div_feedback_settings").addClass("alert-success");
					$("#div_feedback_settings").removeClass("alert-danger");
					$("#div_feedback_settings").css("display", "block");
				} else {
					$("#div_feedback_settings_text").text(res);
					$("#div_feedback_settings").removeClass("alert-success");
					$("#div_feedback_settings").addClass("alert-danger");
					$("#div_feedback_settings").css("display", "block");
				}
			});
		} catch(err) {
			$("#div_feedback_settings_text").text(err.message);
			$("#div_feedback_settings").removeClass("alert-success");
			$("#div_feedback_settings").addClass("alert-danger");
			$("#div_feedback_settings").css("display", "block");
		}
	});
	
	$("#btn_cts_template_save").click(function() {
		$.post( tc_url() + "/ajax_cts_template_save", {cts_template: $('input[name=template]:checked').prop("id")}, function(res){
			if(res === "OK"){
				$("#div_feedback_cts_template_text").text("Settings have been saved successfully!");
				$("#div_feedback_cts_template").addClass("alert-success");
				$("#div_feedback_cts_template").removeClass("alert-danger");
				$("#div_feedback_cts_template").css("display", "block");
			} else {
				$("#div_feedback_cts_template_text").text(res);
				$("#div_feedback_cts_template").removeClass("alert-success");
				$("#div_feedback_cts_template").addClass("alert-danger");
				$("#div_feedback_cts_template").css("display", "block");
			}
		});
	});
	
	
	$(".template_delete_button").click(function() {
		var n = $(this).prop("id").replace("del__", "");
		var conf = confirm("Do you realy want to delete '" + n + "'");
		if(conf){
			$.post( tc_url() + "/ajax_cts_template_delete", {cts_template: n}, function(res){
				var obj = JSON.parse(res);
				if(obj.succ){
					$("#div_feedback_cts_template").addClass("alert-success");
					$("#div_feedback_cts_template").removeClass("alert-danger");
					$("#tr__" + n.replace(".", "_")).remove();
					// set the new active one
					$(".radio_template").each(function(){
						console.log( $(this).text() );
						if($(this).text() == obj.new_active){
							$(this).prop('checked', true);
						}
					})
				} else {
					$("#div_feedback_cts_template").removeClass("alert-success");
					$("#div_feedback_cts_template").addClass("alert-danger");
				}
				$("#div_feedback_cts_template_text").text(obj.msg);
				$("#div_feedback_cts_template").css("display", "block");
			});
		}
	});
	
	
	$(".database_delete_button").click(function() {
		var n = $(this).prop("id").replace("del__db__", "");
		var conf = confirm("Do you realy want to delete the database '" + n + "'");
		if(conf){
			$.post( tc_url() + "/ajax_database_delete", {
				database: $(this).attr("data-dbname"),
				username: $(this).attr("data-username"),
				password: $(this).attr("data-password"),
				host: $(this).attr("data-host"),
				port: $(this).attr("data-port"),
				}, function(res){
				var obj = JSON.parse(res);
				if(obj.succ){
					$("#div_feedback_db_delete").addClass("alert-success");
					$("#div_feedback_db_delete").removeClass("alert-danger");
					$("#tr__db__" + n.replace(".", "_")).remove();
				} else {
					$("#div_feedback_db_delete").removeClass("alert-success");
					$("#div_feedback_db_delete").addClass("alert-danger");
				}
				$("#div_feedback_db_delete_text").text(obj.msg);
				$("#div_feedback_db_delete").css("display", "block");
			});
		}
	});
	
	
	$("#btn_run_command").click(function() {
		$("#div_feedback_restart").addClass("alert-info");
		$("#div_feedback_restart").removeClass("alert-danger");
		$("#div_feedback_restart").removeClass("alert-success");
		$("#div_feedback_restart_text").text("Please wait...");
		$("#div_feedback_restart").css("display", "block");
		$.post( tc_url() + "/ajax_restart_tomcat", {password: $("#txt_command_password").val() }, function(res){
			var obj = JSON.parse(res);
			if(obj.succ){
				$("#div_feedback_restart").addClass("alert-success");
				$("#div_feedback_restart").removeClass("alert-danger");
				$("#div_feedback_restart").removeClass("alert-info");
			} else {
				$("#div_feedback_restart").addClass("alert-danger");
				$("#div_feedback_restart").removeClass("alert-success");
				$("#div_feedback_restart").removeClass("alert-info");
			}
			$("#div_feedback_restart_text").html(obj.msg);
			$("#div_feedback_restart").css("display", "block");
		});
	});
	
	
	$("#btn_local_restart").click(function() {
		$("#div_feedback_restart").addClass("alert-info");
		$("#div_feedback_restart").removeClass("alert-danger");
		$("#div_feedback_restart").removeClass("alert-success");
		$("#div_feedback_restart_text").text("Please wait...");
		$("#div_feedback_restart").css("display", "block");
		$.post( tc_url() + "/ajax_restart_tomcat_local", {}, function(res){
			var obj = JSON.parse(res);
			if(obj.succ){
				$("#div_feedback_restart").addClass("alert-success");
				$("#div_feedback_restart").removeClass("alert-danger");
				$("#div_feedback_restart").removeClass("alert-info");
			} else {
				$("#div_feedback_restart").addClass("alert-danger");
				$("#div_feedback_restart").removeClass("alert-success");
				$("#div_feedback_restart").removeClass("alert-info");
			}
			$("#div_feedback_restart_text").html(obj.msg);
			$("#div_feedback_restart").css("display", "block");
		});
	});
	
	// ################################################################################
	// ##### User Management  #########################################################
	// ################################################################################
	
	// delegation needed when dynamically adding rows with users (new row will not
	// bind events if just $(".user_save_button").click(...) is used )
	$("#user_table").on("click", ".user_save_button", function(){
		var username = $(this).prop("id").split("__")[1];
		
		$.post( tc_url() + "/ajax_user_save", {
			uname: 		username,
			role: 		$("#role__" + username).val(), 
			new_pw: 	$("#new_pw__" + username).val(), 
			new_pw2: 	$("#new_pw2__" + username).val()},
			function(res){
				$("#new_pw__" + username).val("");
				$("#new_pw2__" + username).val("");
				usermanagement_ruby_feedback(res);
			});
	});
	
	$("#user_table").on("click", ".user_delete_button", function(){
		var username = $(this).prop("id").split("__")[1];
		var res = confirm("Are you sure that you want to delete the user '" + username + "'");
		if(res === true){
			$.post( tc_url() + "/ajax_user_delete", {username: username,}, 
				function(res){
					var obj = JSON.parse(res);
					if(obj.succ === true){
						// remove row from table
						$('#row__' + username).remove();
					}
					usermanagement_ruby_feedback(res);
				});
		}
	});
	
	$(".user_create_button").click(function(){
		$.post( tc_url() + "/ajax_user_create", {
				uname: 		$("#create_name").val(), 
				role: 		$("#create_role").val(), 
				new_pw: 	$("#create_new_pw").val(), 
				new_pw2: 	$("#create_new_pw2").val()}, 
			function(res){
				var obj = JSON.parse(res);
				console.dir(obj);
				if(obj.succ === true){
					var sele = {Admin: "", User: "", Guest: ""};
					var username = $("#create_name").val();
					sele[$("#create_role").val()] = "selected";
					// update table above
					var html = '<tr id="row__' + username + '"><td>' + username + '</td>'
					html += '<td><select id="role__' + username + '" class="form-control" >'
					html += '<option id="opt_admin" ' + sele["Admin"] + '>Admin</option>'
					html += '<option id="opt_user"  ' + sele["User"] + '>User</option>'
					html += '<option id="opt_guest" ' + sele["Guest"] + '>Guest</option>'
					html += '</select></td>'
					html += '<td><input id="new_pw__' + username + '"  type="password" class="form-control"></td>'
					html += '<td><input id="new_pw2__' + username + '" type="password" class="form-control"></td>'
					html += '<td class="table_middle"><span id="save__' + username + '" class="glyphicon glyphicon-floppy-save user_save_button user_clickable_button" aria-hidden="true"></span></td>'
					html += '<td class="table_middle"><span id="del__' + username + '" class="glyphicon glyphicon-trash user_delete_button user_clickable_button" aria-hidden="true"></span></td></tr>';
					$('#user_table > tbody > tr').eq(-2).after(html);
					
					// empty the fields
					$("#create_name").val("");
					$("#create_role").val("Guest");
					$("#create_new_pw").val("");
					$("#create_new_pw2").val("");
				} 
				usermanagement_ruby_feedback(res);
			}
		);
	});
	
	
	// ################################################################################
	// #####  Alignment   #############################################################
	// ################################################################################
	
	// $(".algin_candi").click(function(){
	// 	var candi_urn = $(this).attr("data-urn");
	// 	console.log(candi_urn);
	// 	var base_url = $("#align_base_url").attr("data-url");
	// 	console.log(base_url);
	// 	var align_url = base_url + "urnstypestext?urn=" + candi_urn;
	// 	console.log(align_url);
		
	// 	var get_ret = $.get(align_url)
	// 	console.log(get_ret);
	// });
	
	// ################################################################################
	// ##### external Tools reset  ####################################################
	// ################################################################################
	
	$(".tool_delete_button").click(function() {
		$.post( tc_url() + "/ajax_delete_tools", {tool: $(this).prop("id") }, function(res){
			var obj = JSON.parse(res);
			if(obj.succ){
				$("#div_feedback_tools").addClass("alert-success");
				$("#div_feedback_tools").removeClass("alert-danger");
			} else {
				$("#div_feedback_tools").addClass("alert-danger");
				$("#div_feedback_tools").removeClass("alert-success");
			}
			$("#div_feedback_tools_text").html(obj.msg);
			$("#div_feedback_tools").css("display", "block");
		});
	});
	
	
}


// bind to the ready and pagechange function (for AJAX requests)
$(document).ready( func_ready )
$(document).on("pagechange", func_ready )