# TRAViz
Text Re-use Alignment Visualization

By Stefan Jänicke.

## Introduction

One of the substantial tasks in the ﬁeld of textual criticism is called collation, which is the cautious comparison of various editions of one and the same text. The traditional approach of a humanities scholar is to put the texts of several editions next to each other and mark the differences among the textual entities (e.g., sentences, sections, chapters). Since this is an extremely laborious approach many Digital Humanities projects investigate tools that support the humanities scholars with computational methods.

TRAViz is a JavaScript library that was developed within the Digital Humanities project eTRACES (http://etraces.e-humanities.net/). It generates visualizations for Text Variant Graphs that show the variations between different editions of texts. TRAViz supports the collation task by providing methods to:
* align various editions of a text
* visualize the alignment
* improve the readability for Text Variant Graphs compared to other approaches
* interact with the graph to discover how individual editions disseminate

## License

TRAViz is licensed under the latest Version of the Fair Academic License (FAL). 

FAL for TRAViz: http://www.traviz.vizcovery.org/source.html

More information about FAL can be found under http://www.vizcovery.org/fal.html.

## Homepage

http://www.traviz.vizcovery.org/
