// shows an error message if something went wrong
function error(msg){
	console.log("[ALIGNBROWSER-ERROR] " + msg);
	$("#align_error_msg").text(msg);
	$("#align_error_div").css("display", "block");
};
// hides the error message. e.g. when a new action is triggered from the beginning
function reset_error(){
	$("#align_error_div").css("display", "none");
};


// automatically resize the iFrame every now and then to adopt its height
// so that the iframe has the same height as the graphic. This will prevent
// a second scrollbar inside the iframe
function autoresize_irame() {
	if(graphic_iframe.contentWindow.document.body){
		var graphic_iframe_size = graphic_iframe.contentWindow.document.body.offsetHeight;
		if(document.all && !window.opera) {
			graphic_iframe_size = graphic_iframe.contentWindow.document.body.scrollHeight;
		}
		graphic_iframe.style.height = graphic_iframe_size + 'px';
	}
}

// set the new stepwidth when the plus and minus buttons are clicked
function button_stepwidth(inc){
	// get old value
	var old_var = parseInt($("#txt_stepwidth").val());
	// and add +1 or -1
	var new_var = old_var + inc;
	// test if out of bound or NaN	
	if(new_var < 1 || isNaN(new_var)){
		new_var = 1
	}
	// set new value
	$("#txt_stepwidth").val(new_var);
};




function toggle_fold(level){
	// get the element with this data-level
	var el = $('*[data-level="' + level + '"]');
	console.log(el);
	
	// form the items with this class, which display-property should be toggled
	var cls = "fold__" + level.replace(/\./g, "__");
	$("." + cls).each(function(){
		// toggle if should be shown or not
		$(this).toggleClass("hidden");
	});
	
	// change the triangle facing direction
	el.find("span").toggleClass("glyphicon-triangle-bottom");
	el.find("span").toggleClass("glyphicon-triangle-right");
};



// ################################################################################
// #####  Left / Right  ###########################################################
// ################################################################################



function goto_left_right(direction){
	// parse the value from the textfield and make it sane
	var steps = parseInt($("#txt_stepwidth").val());
	if(steps < 1 || isNaN(steps)){
		steps = 1;
	}
	console.log("going " + direction + " for " + steps + " steps");
	
	// get the name of the CTS. The name is given via the URL
	var cts_url = window.location.search.split('&')[0].split("=")[1];
	console.log("cts_url=" + cts_url);
	console.log("sentence_url=" + urn);
	
	// http://ctstest.informatik.uni-leipzig.de/pbc/plain/left?urn=urn:cts:pbc:deu.elberfelder1905:1.3.5-1.3.7&steps=4
	// http://ctstest.informatik.uni-leipzig.de/pbc/plain/right?urn=urn:cts:pbc:deu.elberfelder1905:1.3.5-1.3.7&steps=4
	var dir_url = cts_url + "/plain/" + direction + "?urn="  + urn + "&steps=" + steps;
	console.log("dir_url=" + dir_url);
	// http://ctstest.informatik.uni-leipzig.de/pbc/plain/alignments?urn=urn:cts:pbc:deu.elberfelder1905:1.3.5-1.3.7
	$.get( dir_url )
		.done( function( res ) {
			// get the builded urn-string
			var ret = build_align_url(res, cts_url, urn);
			
			// maybe open folded items
			var base_urn = ret.first.slice(0, ret.first.lastIndexOf(":"));
			console.log("open unfolded...");
			console.dir(ret.arr);
			for (var i = 0; i < ret.arr.length; i++) {
				var nums = ret.arr[i].replace(base_urn + ":", "");
				var num_arr = nums.split(".");
				var lvl = "";
				for (var k = 0; k < num_arr.length-1; k++) {
					if(k > 0){
						lvl += ".";
					}
					lvl += num_arr[k];
					var el = $('*[data-level="' + lvl + '"]');
					if( el.find("span").hasClass("glyphicon-triangle-bottom") ){
						toggle_fold(lvl);
					}
				};
			};
			// and after opening folds, scroll inside the list
			var container = $('#align_sentence_list');
			var scrollTo  = $('*[data-urn="' + ret.first + '"]');
			container.scrollTop(
				scrollTo.offset().top - container.offset().top + container.scrollTop() - 40
			);
			
			// set the fullscreen-url
			$("#a_browser_full").attr("href", "");
			var bas = $("#a_browser_full").prop( "href" ) ;
			$("#a_browser_full").attr("href", bas + "&urn=" + ret.urn.split("&urn=")[1] + "&stepwidth=" + $("#txt_stepwidth").val() );
	
			// set the passage url for this view
			var passage_url = "../" + cts_url + "/cts/?request=GetPassage&urn=" + ret.urn.split("&urn=")[1];
			$("#passage_link").prop("href", passage_url);
			$("#passage_link").text( $("#passage_link").prop("href") );
			
			// check if the align graph should be shown
			var show_graph = true
			if( $('#chk_warnings').is(':checked') && ret.len > 1000 ){
				show_graph = confirm("The total length is " + ret.len + ". It will probably take a long time to render the graphic. To you really want to continue?");
			}
			if(show_graph){
				// set url for full screen
				$("#a_graphic_full").prop("href", ret.urn);
				// reduce the height of the iframe since there a problems in the automatic resize of the iframe if it goed from big to small
				$("#iframe_alignment").height("10px");
				// load the Traviz-Tool in the iframe
				$("#iframe_alignment").attr("src", ret.urn);
			}
		})
		.fail(function() {
			error("Could not get new URL while going left/right.");
		});
}


// build the new (spanning) url from the left_right call
// - res is the answer from the left/right call = set of possible start/end points
// - cts_url is the url for the current cts. the cts-name has to be extracted
// - start_urn is the urn for which the left/right-call has been made
// 1) build an array (list) from the GET-result
// 2) remove all elements that do not have the same base-urn
// 3) remove all elements that do not have a lenght attribute
// 4) take the first and the last element of the array as boundaries
function build_align_url(res, cts_url, start_urn){
	var ret = {new_urn: "", len: 0, first: "", last: "", arr: []};
	
	console.log("res_start -->");
	console.log(res);
	console.log("<-- res_end");
	
	// split the results into lines and thus build an array
	var urn_list = res.split("\n");
	console.dir(urn_list);
	
	// get the base_urn for which the left/right function has been called
	var base_urn = start_urn.slice(0, start_urn.lastIndexOf(":"));
	console.log("start_urn = " + start_urn);
	console.log("base_urn = " + base_urn);
	// the base_urn has to be present in the entries. But it could change if we
	// go over the urn-boundaries (e.g. at *:1.1.1, going left 6 steps will result)
	// in another base_urn (*:23.9.25). Thus, only keep entries with the start-base-urn
	for (var i = urn_list.length - 1; i >= 0; i--) {
		// loop over the array from the end to safely delete entries on the fly
		if(urn_list[i].indexOf(base_urn) !== 0){
			// if the start-base-urn could not be found, delete this entry
			urn_list.splice(i, 1);
		}
	};
	console.dir(urn_list);
	
	// both boundarie-entries need to have a text-length. All urn's with a text-length
	// are stored in the array valid_build_urns_globalvar
	// valid_build_urns_globalvar only keeps the ending numbers but not the base-urn itself
	for (var i = urn_list.length - 1; i >= 0; i--) {
		if(! (urn_list[i].replace(base_urn + ":", "") in valid_build_urns_globalvar)){
			// if is not valid, delete it
			urn_list.splice(i, 1);
		}
	};
	
	// the urn-list is now only containing valid candidates for the boundaries
	// take the first and the last entry and build a spanning urn
	if(urn_list.length > 0){
		var start  = urn_list[0];
		ret.first  = start; 
		var ending = urn_list[urn_list.length-1];
		ret.last   = ending;
		ret.arr    = urn_list;
		console.log(start, ending);
		urn = start + ending.replace(base_urn + ":", "-");
		
		// set active flag for the clicked entry
		$(".clickable").removeClass("active");
		for (var i = urn_list.length - 1; i >= 0; i--) {
			// add up the lengths
			ret.len += valid_build_urns_globalvar[urn_list[i].replace(base_urn + ":", "")];
			// mark all view sentences
			$('*[data-urn="' + urn_list[i] + '"]').addClass("active");
		};
	} else {
		// no more valid candidates. we cannot go left or right. stay, where we are
		urn = start_urn;
	}
	
	// http://localhost:8080/Alignment/?cts=cts&urn=urn:cts:pbc:deu.luther1912:1.1.1-1.1.3
	var cts = cts_url.split("/").slice(-1)[0];
	ret.urn = "../Alignment/?cts=../" + cts + "&urn=" + urn;
	console.log("New URL = " + ret.urn);
	console.log("Length = " + ret.len);
	
	return ret
}




// ################################################################################
// #####  Func Ready  #############################################################
// ################################################################################





function func_ready() {
	
	// ################################################################################
	// #####  Done at Startup  ########################################################
	// ################################################################################
	
	// later on: save all valid sentence-urn (the ones that have a length)
	// to check if we could build a urn from them in the left/right-function
	valid_build_urns_globalvar = {};
	
	// needed for automatic resize of the iFrame with the Traviz-Tool (mainly height)
	graphic_iframe = document.getElementById("iframe_alignment");
	auto_resize_timer = window.setInterval("autoresize_irame()", 400);
	
		
	// get the name of the CTS. The name is given via the URL. And also the current shown urn
	var params = window.location.search.split('&');
	var cts_url = params[0].split('=')[1];
	console.log("cts_url = " + cts_url);
	var shown_urn = "";
	var show_urn_start = "";
	var show_urn_end = "";
	var show_arr = [];
	if(params.length > 1){
		shown_urn = params[1].split('=')[1];
		console.log("shown_urn = " + shown_urn);
		
		// set the stepwidth from former view
		stepwidth = params[2].split('=')[1] || 1;
		$("#txt_stepwidth").val(stepwidth);
		
		////////////////////
		// show information
		////////////////////
		
		// get the full urn of the sentence from the data-field
		urn = shown_urn;
		var cts = cts_url.split("/").slice(-1)[0];
		
		// build the url for the Travis-Tool
		// http://localhost:8080/Alignment/?cts=cts&urn=urn:cts:pbc:deu.luther1912:1.1.1-1.1.3
		var graph_url = "../Alignment/?cts=../" + cts + "&urn=" + urn;
		console.log("graph_url = " + graph_url);
		
		// set the passage url for this view
		var passage_url = "../" + cts + "/cts/?request=GetPassage&urn=" + urn;
		$("#passage_link").prop("href", passage_url);
		$("#passage_link").text( $("#passage_link").prop("href") );
		
		// set url for full screen
		$("#a_graphic_full").prop("href", graph_url);
		// reduce the height of the iframe since there a problems in the automatic resize of the iframe if it goed from big to small
		$("#iframe_alignment").height("10px");
		// load the Traviz-Tool in the iframe
		$("#iframe_alignment").attr("src", graph_url);
		
		////////////////////////
		// store stuff to mark entries as active on the right side
		////////////////////////
		
		var show_urn_nums  	= shown_urn.slice(shown_urn.lastIndexOf(":")+1, shown_urn.length);
		var show_urn_nums_arr  = show_urn_nums.split("-")
		show_urn_start 	= show_urn_nums_arr[0];
		show_urn_end 	= show_urn_nums_arr[1] || show_urn_nums_arr[0];
	}
	
	// build the url to ask for the alignment candidates for this CTS
	// http://ctstest.informatik.uni-leipzig.de/pbc/plain/alignmentcandidates
	var align_candi_url = cts_url + "/plain/alignmentcandidates";
	console.log("align_candi_url = " + align_candi_url);
	
	// get the alignment candidates for this specific CTS via GET command
	$.get( align_candi_url )	
		// if GET was successfull
		.done( function( alignment_candis ) {
			// reset error if there were errors before
			reset_error();
			// empty the left list of alignment candidates
			$("#align_candi_list").html("");
			// check, if this CTS has any candidates
			if(alignment_candis !== ""){
				var candi_arr = alignment_candis.split("\n");
				// fill the left list with all the candidates
				for (var i = 0; i < candi_arr.length; i++) {
					var str = candi_arr[i];
					// filter for empty lines, e.g. at the end of the transmission
					if(str !== ""){
						// check if this candidate is a feasible candidate:
						// it is feasible if it has a successor with a \t or itself has a \t
						var addto_class = "";
						if( ! ( str.indexOf("\t") != -1 || ((i+1 < candi_arr.length) && candi_arr[i+1].indexOf("\t") != -1) ) ){
							addto_class = "unfeasible";
						}
						// some candidates are indented. BUT this MUST NOT be used within urn-requests
						var urn = str.replace(/\t/g, "");
						// some candidates are indented. For better HTML rendering, convert to non-breakables spaces
						var txt = str.replace(/\t/g, "&nbsp;&nbsp;&nbsp;&nbsp;");
						// add a new list item and add the urn as a data-field
						$("#align_candi_list").append('<a class="list-group-item list-group-item-default algin_candi ' + addto_class + '" data-urn="' + urn + '">' + txt + '</a>')
					}
				};
				
				//
				if(shown_urn !== ""){
					var tmp_bas = shown_urn.slice(0, shown_urn.lastIndexOf(":"));
					$('*[data-urn="' + tmp_bas + ':"]').trigger("click");
				}
				
			} else {
				// if there were no alignment candidates, show a short message in the list
				$("#align_candi_list").append('<a class="list-group-item list-group-item-default">No alignment candidates found</a>');
			}
		})  
		// in case of errors during the conncetion show the error
		.fail(function() {
			$("#align_candi_list").html('<a class="list-group-item list-group-item-default">Could not connect to: ' + align_candi_url + '</a>');
			error("Could not connect to: " + align_candi_url);
		});
	
	
	// ################################################################################
	// #####  Click-Event for left list  ##############################################
	// ################################################################################
	
	
	// handle clicks on the alignment-candidates 
	// 		-> Show sentence candidates in the right list
	// use delegation since alignment-candidates are added dynamically at startup
	$("#align_candi_list").on('click', '.algin_candi', function() {
		// reset error if there were errors before
		reset_error();
		// set active flag for only the clicked alignment-candidate entry
		$(".algin_candi").removeClass("active");
		$(this).addClass("active");
		
		// get urn for this candidate by reading its data-field
		var align_candi_urn = $(this).attr("data-urn");
		console.log("alignment-candidate clicked: " + align_candi_urn);
		
		// build the url to get all sentence candidates
		// http://ctstest.informatik.uni-leipzig.de/dev/plain/urnstypestext?urn=urn:cts:pbc:hif.hif: 
		var sentences_candidates_url = cts_url + "/plain/urnstypestext?urn=" + align_candi_urn;
		console.log("sentences_candidates_url=" + sentences_candidates_url);
		
		// remove all items but the first one in the right list
		$('#align_sentence_list a:not(:first)').remove();
		// // show that we are loading stuff
		$("#align_sentence_info").html('<span class="glyphicon glyphicon-refresh glyphicon-refresh-animate"></span> loading');
		
		// get a list of all sentences for this alignment candidate via GET request
		$.get( sentences_candidates_url )
			// in case of successfull GET
			.done( function( sentence_candis ) {
				// remove all items but the first one
				$('#align_sentence_list a:not(:first)').remove();
				
				// check if there were any sentence candidates
				if(sentence_candis !== ""){
					// give some feedback in the info-entry
					var sentence_list = sentence_candis.split("\n");
					$("#align_sentence_info").text("found " + sentence_list.length + " lines");
					
					// init some temporary variables
					var line_arr = [];	// temp. array of the splitted entries for one line
					var sub_urn  = "";	// the reduced sub-urn of this sentence (without the alignment-candidates urn!)
					var sub_type = "";	// type could be chapter, book, sentence, ...
					var sub_len  = "";	// length of the entry. Only make entries clickable that have a length (and not "-")
					var cls 	 = ""; 	// mark entries as clickable by adding a custom clickable class
					var indent   = "";	// indent according to urn-depth
					valid_build_urns_globalvar = {};
					
					// boolean if sould shown
					var should_shown_extern = false;
					
					// list all found sentence candidates
					for (var i = 0; i < sentence_list.length; i++) {
						// split the line at tabs. It will then have 3 entries
						line_arr = sentence_list[i].split("\t");
						// 1. the full urn of this sentence. remove the candidates urn to only store the sentence specific identifier
						sub_urn  = line_arr[0].replace(align_candi_urn, "");
						// read the type of this line. could be chapter, sentence, ...
						sub_type = line_arr[1];
						// and read the length-information
						sub_len  = line_arr[2];
						
						// if this line has a length, it could be displayed in the alignment-TRaviz and thus a clickable entry 
						if(sub_len !== "-"){
							cls = " clickable";
							valid_build_urns_globalvar[sub_urn] = parseInt(sub_len);
						} else {
							// if not, it could be used for a clickable fold hierarchy
							cls = " foldable";
						}
						
						// hide everything on initial display but the topmost level
						if(sub_urn.indexOf(".") >= 0){
							// hide but setting the hidden class
							cls += " hidden";
							// add a class which describes the upper fold-button-level which
							// a click on a button with this level will toggle the hidden status. this makes fold and unfold very easy and efficient!
							// just remove the last entry after the dot to get the upper level
							cls += " fold__" + sub_urn.slice(0, sub_urn.lastIndexOf(".") ).replace(/\./g, "__");
						}
						
						// convert the depth=tabs into nice indentation
						indent   = "";
						for (var k = 0; k < sub_urn.split(".").length - 1; k++) {
							indent += "&nbsp;&nbsp;&nbsp;&nbsp;";
						};
						
						// do not print "(-)" for book or chapter
						var print_len = ' (' + sub_len + ')';
						if( sub_len === "-"){
							//  !!! IMPORTANT the glyphicon-triangle-bottom is used to indicate if folded or not !!!
							print_len = ' <span class="glyphicon glyphicon-triangle-bottom"></span>';
						}
						
						// add a list entry
						if(sub_urn != ""){
							if( show_urn_start !== "" && sub_urn === show_urn_start ){
								should_shown_extern = true;
							}
							if(should_shown_extern && sub_len !== "-"){
								cls += " active ";
								show_arr.push(sub_urn);
							}
							
							$("#align_sentence_list").append('<a class="list-group-item list-group-item-default list_sent' + cls + '" data-urn="' + line_arr[0] + '" data-level="' + sub_urn + '">' + indent + '('+sub_urn+') ' + sub_type + print_len + '</a>');
							
							if( show_urn_end !== "" && sub_urn === show_urn_end ){
								should_shown_extern = false;
							}
						}
					}
					if(show_arr.length > 0){
						console.dir(show_arr);
						// unfold stuff
						for (var i = 0; i < show_arr.length; i++) {
							var num_arr = show_arr[i].split(".");
							var lvl = "";
							for (var k = 0; k < num_arr.length-1; k++) {
								if(k > 0){
									lvl += ".";
								}
								lvl += num_arr[k];
								var el = $('*[data-level="' + lvl + '"]');
								if( el.find("span").hasClass("glyphicon-triangle-bottom") ){
									toggle_fold(lvl);
								}
							};
						};
						// and after opening folds, scroll inside the list
						var container = $('#align_sentence_list');
						var scrollTo  = $('*[data-level="' + show_arr[0] + '"]');
						container.scrollTop(
							scrollTo.offset().top - container.offset().top + container.scrollTop() - 40
						);
						
						// reset variables to only show on first call and not on regular clicks
						show_arr = [];
						show_urn_end = "";
						show_urn_start = "";
					}
					
					
				} else {
					// if there were no sentence candidates, show this as list entry
					$("#align_sentence_info").text("No sentence candidates available.");
				}
			})
			// in case of error, show the error
			.fail(function() {
				error("Could not get the sentence candidates, url = " + sentences_candidates_url);
			});
	});
	
	
	
	// ################################################################################
	// #####  Click-Event for right list  #############################################
	// ################################################################################
	
	
	// handle clicks on the sentence-candidates
	// 		-> Show in graphical alignment frame
	// use delegation since sentence candidates are added dynamically
	$("#align_sentence_list").on('click', '.clickable', function() {
		// reset error if there were some before
		reset_error();
		// set active flag for the clicked entry
		$(".clickable").removeClass("active");
		$(this).addClass("active");
		
		// the loading animation is not really shown... And there is no real mean to get the event 
		// when the Traviz has finished rendereding inside the browser
		// $("#iframe_alignment").attr("src", "./align_load.html");
		
		// get the full urn of the sentence from the data-field
		urn = $(this).attr("data-urn");
		var cts = cts_url.split("/").slice(-1)[0];
		
		// build the url for the Travis-Tool
		// http://localhost:8080/Alignment/?cts=cts&urn=urn:cts:pbc:deu.luther1912:1.1.1-1.1.3
		var graph_url = "../Alignment/?cts=../" + cts + "&urn=" + urn;
		console.log("graph_url = " + graph_url);
		
		// set the browser fullscreen-url
		$("#a_browser_full").attr("href", "");
		var bas = $("#a_browser_full").prop( "href" ) ;
		$("#a_browser_full").attr("href", bas + "&urn=" + urn + "&stepwidth=" + $("#txt_stepwidth").val() );
		
		// set the passage url for this view
		var passage_url = "../" + cts + "/cts/?request=GetPassage&urn=" + urn;
		$("#passage_link").prop("href", passage_url);
		$("#passage_link").text( $("#passage_link").prop("href") );
		
		// set url for full screen
		$("#a_graphic_full").prop("href", graph_url);
		// reduce the height of the iframe since there a problems in the automatic resize of the iframe if it goed from big to small
		$("#iframe_alignment").height("10px");
		// load the Traviz-Tool in the iframe
		$("#iframe_alignment").attr("src", graph_url);
	});
	
	
	// handle clicks on the foldable-items
	// 		-> fold / unfold stuff
	// use delegation since items are added dynamically
	$("#align_sentence_list").on('click', '.foldable', function() {
		// get the level of the current item
		var level = $(this).attr("data-level");
		// toggle the fold status
		toggle_fold(level);
	});
	
	
	
	// ################################################################################
	// #####  Gimmicks  ###############################################################
	// ################################################################################
	
	
	// click on the unfeasible checkbox
	$("#chk_feasible").click(function() {
		var only_feasible = $("#chk_feasible").is(":checked");
		if(only_feasible){
			$(".unfeasible").removeClass("shown");
		} else {
			$(".unfeasible").addClass("shown");
		}
	});
	
	
	
	// regexp filter while typing in the search field
	// use the keyup event because then we get the final input (in contrast to keypress or keydown)
	$("#txt_regex").on("keyup", function(){
		// read the regexp
		var reg_string = $("#txt_regex").prop("value");
		// i - case-insensitive ; g - global ; m - multi
		var regexp = new RegExp(reg_string, "i");
		// show matching candidates. no need to check for empty regexp, will match all anyway
		// for each candidate in the list
		$(".algin_candi").each(function(){
			// test if matching
			if( $(this).text().search(regexp) >= 0 ){
				$(this).css("display", "block");
			} else {
				$(this).css("display", "none");
			}
		});
	});
	
	
	// handle plus // minus stepwidth clicks
	$("#btn_stepwidth_minus").click(function() {
		button_stepwidth(-1);
	});
	$("#btn_stepwidth_plus").click(function() {
		button_stepwidth(1);
	});
	
	// go left or right button clicks
	$("#btn_left").click(function(){
		goto_left_right("left");
	});
	$("#btn_right").click(function(){
		goto_left_right("right");
	});
}




// bind to the ready and pagechange function (for AJAX requests)
$(document).ready( func_ready )
$(document).on("pagechange", func_ready )


// bind keydown events for going left or right (left or right arrows)
$(document).keydown(function(e) {
    //left
    if(e.keyCode === 37){
    	goto_left_right("left");
    }
	// right
    if (e.keyCode === 39) {
    	goto_left_right("right");
    }
});







					